<Activity mc:Ignorable="sap sap2010" x:Class="Initialize_Transactions_Sequence" xmlns="http://schemas.microsoft.com/netfx/2009/xaml/activities" xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" xmlns:mva="clr-namespace:Microsoft.VisualBasic.Activities;assembly=System.Activities" xmlns:s="clr-namespace:System;assembly=mscorlib" xmlns:sap="http://schemas.microsoft.com/netfx/2009/xaml/activities/presentation" xmlns:sap2010="http://schemas.microsoft.com/netfx/2010/xaml/activities/presentation" xmlns:scg="clr-namespace:System.Collections.Generic;assembly=mscorlib" xmlns:sd="clr-namespace:System.Data;assembly=System.Data" xmlns:tca="clr-namespace:TMC.CVLEmailing.Activities;assembly=TMC.CVLEmailing.Activities" xmlns:tcm="clr-namespace:TMC.CVLEmailing.Models;assembly=TMC.CVLEmailing" xmlns:ui="http://schemas.uipath.com/workflow/activities" xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml">
  <x:Members>
    <x:Property Name="In_Config" Type="InArgument(scg:Dictionary(x:String, x:Object))" />
    <x:Property Name="IO_DataTablesDictionary" Type="InOutArgument(scg:Dictionary(x:String, sd:DataTable))" />
    <x:Property Name="IO_Transactions" Type="InOutArgument(sd:DataTable)" />
    <x:Property Name="IO_Results" Type="InOutArgument(tcm:Results)" />
  </x:Members>
  <mva:VisualBasic.Settings>
    <x:Null />
  </mva:VisualBasic.Settings>
  <sap:VirtualizedContainerService.HintSize>1218,2181</sap:VirtualizedContainerService.HintSize>
  <sap2010:WorkflowViewState.IdRef>Initialize_Transactions_Sequence_1</sap2010:WorkflowViewState.IdRef>
  <TextExpression.NamespacesForImplementation>
    <scg:List x:TypeArguments="x:String" Capacity="34">
      <x:String>System.Activities</x:String>
      <x:String>System.Activities.Statements</x:String>
      <x:String>System.Activities.Expressions</x:String>
      <x:String>System.Activities.Validation</x:String>
      <x:String>System.Activities.XamlIntegration</x:String>
      <x:String>Microsoft.VisualBasic</x:String>
      <x:String>Microsoft.VisualBasic.Activities</x:String>
      <x:String>System</x:String>
      <x:String>System.Collections</x:String>
      <x:String>System.Collections.Generic</x:String>
      <x:String>System.Data</x:String>
      <x:String>System.Diagnostics</x:String>
      <x:String>System.Drawing</x:String>
      <x:String>System.IO</x:String>
      <x:String>System.Linq</x:String>
      <x:String>System.Net.Mail</x:String>
      <x:String>System.Xml</x:String>
      <x:String>System.Xml.Linq</x:String>
      <x:String>UiPath.Core</x:String>
      <x:String>UiPath.Core.Activities</x:String>
      <x:String>System.Windows.Markup</x:String>
      <x:String>System.Collections.ObjectModel</x:String>
      <x:String>System.ComponentModel</x:String>
      <x:String>System.Runtime.Serialization</x:String>
      <x:String>System.Xml.Serialization</x:String>
      <x:String>System.Activities.DynamicUpdate</x:String>
      <x:String>System.Reflection</x:String>
      <x:String>System.Runtime.InteropServices</x:String>
      <x:String>GlobalVariableScope</x:String>
      <x:String>TMC.CVLEmailing.Models</x:String>
      <x:String>TMC.CVLEmailing.Activities</x:String>
      <x:String>UiPath.Shared.Activities</x:String>
      <x:String>UiPath.Excel.Activities</x:String>
      <x:String>UiPath.Excel</x:String>
    </scg:List>
  </TextExpression.NamespacesForImplementation>
  <TextExpression.ReferencesForImplementation>
    <scg:List x:TypeArguments="AssemblyReference" Capacity="32">
      <AssemblyReference>System.Activities</AssemblyReference>
      <AssemblyReference>Microsoft.VisualBasic</AssemblyReference>
      <AssemblyReference>mscorlib</AssemblyReference>
      <AssemblyReference>System.Data</AssemblyReference>
      <AssemblyReference>System.Data.DataSetExtensions</AssemblyReference>
      <AssemblyReference>System</AssemblyReference>
      <AssemblyReference>System.Drawing</AssemblyReference>
      <AssemblyReference>System.Core</AssemblyReference>
      <AssemblyReference>System.Xml</AssemblyReference>
      <AssemblyReference>System.Xml.Linq</AssemblyReference>
      <AssemblyReference>PresentationFramework</AssemblyReference>
      <AssemblyReference>WindowsBase</AssemblyReference>
      <AssemblyReference>PresentationCore</AssemblyReference>
      <AssemblyReference>System.Xaml</AssemblyReference>
      <AssemblyReference>UiPath.System.Activities</AssemblyReference>
      <AssemblyReference>UiPath.UiAutomation.Activities</AssemblyReference>
      <AssemblyReference>System.Runtime.Serialization</AssemblyReference>
      <AssemblyReference>GlobalVariableScope</AssemblyReference>
      <AssemblyReference>UiPath.System.Activities.Design</AssemblyReference>
      <AssemblyReference>TMC.CVLEmailing</AssemblyReference>
      <AssemblyReference>TMC.CVLEmailing.Activities</AssemblyReference>
      <AssemblyReference>UiPath.Mail.Activities</AssemblyReference>
      <AssemblyReference>UiPath.Excel.Activities</AssemblyReference>
      <AssemblyReference>UiPath.PDF.Activities</AssemblyReference>
      <AssemblyReference>UiPath.CV</AssemblyReference>
      <AssemblyReference>System.ServiceModel</AssemblyReference>
      <AssemblyReference>System.ValueTuple</AssemblyReference>
      <AssemblyReference>System.ComponentModel.Composition</AssemblyReference>
      <AssemblyReference>UiPath.Mail</AssemblyReference>
      <AssemblyReference>UiPath.Excel</AssemblyReference>
      <AssemblyReference>System.Memory</AssemblyReference>
    </scg:List>
  </TextExpression.ReferencesForImplementation>
  <Sequence DisplayName="Initialize Transactions" sap:VirtualizedContainerService.HintSize="636,2116" sap2010:WorkflowViewState.IdRef="Sequence_1">
    <sap:WorkflowViewStateService.ViewState>
      <scg:Dictionary x:TypeArguments="x:String, x:Object">
        <x:Boolean x:Key="IsExpanded">True</x:Boolean>
      </scg:Dictionary>
    </sap:WorkflowViewStateService.ViewState>
    <Sequence DisplayName="Load transactions" sap:VirtualizedContainerService.HintSize="594,1131" sap2010:WorkflowViewState.IdRef="Sequence_2">
      <Sequence.Variables>
        <Variable x:TypeArguments="s:String[]" Name="SOAFiles" />
      </Sequence.Variables>
      <sap:WorkflowViewStateService.ViewState>
        <scg:Dictionary x:TypeArguments="x:String, x:Object">
          <x:Boolean x:Key="IsExpanded">True</x:Boolean>
          <x:Boolean x:Key="IsPinned">False</x:Boolean>
        </scg:Dictionary>
      </sap:WorkflowViewStateService.ViewState>
      <ui:LogMessage DisplayName="Log Message" sap:VirtualizedContainerService.HintSize="552,91" sap2010:WorkflowViewState.IdRef="LogMessage_1" Level="Info" Message="[String.Format(&quot;[CVL Emailing: Initialize Process] &gt; [Initialize Transactions] Getting SOA files in {0}&quot;, In_Config(&quot;soa_dir&quot;).ToString.Trim)]" />
      <ui:BuildDataTable DataTable="[IO_Transactions]" DisplayName="Build Transactions" sap:VirtualizedContainerService.HintSize="552,59" sap2010:WorkflowViewState.IdRef="BuildDataTable_1" TableInfo="&lt;NewDataSet&gt;&#xA;  &lt;xs:schema id=&quot;NewDataSet&quot; xmlns=&quot;&quot; xmlns:xs=&quot;http://www.w3.org/2001/XMLSchema&quot; xmlns:msdata=&quot;urn:schemas-microsoft-com:xml-msdata&quot;&gt;&#xA;    &lt;xs:element name=&quot;NewDataSet&quot; msdata:IsDataSet=&quot;true&quot; msdata:MainDataTable=&quot;TableName&quot; msdata:UseCurrentLocale=&quot;true&quot;&gt;&#xA;      &lt;xs:complexType&gt;&#xA;        &lt;xs:choice minOccurs=&quot;0&quot; maxOccurs=&quot;unbounded&quot;&gt;&#xA;          &lt;xs:element name=&quot;TableName&quot;&gt;&#xA;            &lt;xs:complexType&gt;&#xA;              &lt;xs:sequence&gt;&#xA;                &lt;xs:element name=&quot;SOA&quot; type=&quot;xs:string&quot; minOccurs=&quot;0&quot; /&gt;&#xA;              &lt;/xs:sequence&gt;&#xA;            &lt;/xs:complexType&gt;&#xA;          &lt;/xs:element&gt;&#xA;        &lt;/xs:choice&gt;&#xA;      &lt;/xs:complexType&gt;&#xA;    &lt;/xs:element&gt;&#xA;  &lt;/xs:schema&gt;&#xA;&lt;/NewDataSet&gt;">
        <sap:WorkflowViewStateService.ViewState>
          <scg:Dictionary x:TypeArguments="x:String, x:Object">
            <x:Boolean x:Key="IsExpanded">True</x:Boolean>
            <x:Boolean x:Key="IsPinned">False</x:Boolean>
          </scg:Dictionary>
        </sap:WorkflowViewStateService.ViewState>
      </ui:BuildDataTable>
      <ui:ClearDataTable DataTable="[IO_Transactions]" DisplayName="Clear Transactions" sap:VirtualizedContainerService.HintSize="552,22" sap2010:WorkflowViewState.IdRef="ClearDataTable_1" />
      <If Condition="[Boolean.Parse(In_Config(&quot;debug_mode&quot;).ToString.Trim)]" DisplayName="Check if in Debug Mode" sap:VirtualizedContainerService.HintSize="552,224" sap2010:WorkflowViewState.IdRef="If_3">
        <If.Then>
          <Sequence DisplayName="Debug Mode" sap:VirtualizedContainerService.HintSize="200,66" sap2010:WorkflowViewState.IdRef="Sequence_6">
            <sap:WorkflowViewStateService.ViewState>
              <scg:Dictionary x:TypeArguments="x:String, x:Object">
                <x:Boolean x:Key="IsExpanded">False</x:Boolean>
                <x:Boolean x:Key="IsPinned">False</x:Boolean>
              </scg:Dictionary>
            </sap:WorkflowViewStateService.ViewState>
            <Assign DisplayName="Assign SOAFiles - Debug Mode" sap:VirtualizedContainerService.HintSize="262,64" sap2010:WorkflowViewState.IdRef="Assign_5">
              <Assign.To>
                <OutArgument x:TypeArguments="s:String[]">[SOAFiles]</OutArgument>
              </Assign.To>
              <Assign.Value>
                <InArgument x:TypeArguments="s:String[]" xml:space="preserve">[New DirectoryInfo(Path.Combine(In_Config("input_dir").ToString.Trim, "Test Data")).
GetFiles("*.pdf", SearchOption.TopDirectoryOnly).
Where(Function(File) Not File.Attributes.HasFlag(FileAttributes.Hidden)).
Select(Function(File) File.FullName.Trim).ToArray]</InArgument>
              </Assign.Value>
            </Assign>
            <ui:CommentOut DisplayName="Comment Out" sap:VirtualizedContainerService.HintSize="262,51" sap2010:WorkflowViewState.IdRef="CommentOut_1">
              <ui:CommentOut.Body>
                <Sequence DisplayName="Ignored Activities" sap:VirtualizedContainerService.HintSize="304,156" sap2010:WorkflowViewState.IdRef="Sequence_5">
                  <sap:WorkflowViewStateService.ViewState>
                    <scg:Dictionary x:TypeArguments="x:String, x:Object">
                      <x:Boolean x:Key="IsExpanded">True</x:Boolean>
                    </scg:Dictionary>
                  </sap:WorkflowViewStateService.ViewState>
                  <Assign DisplayName="Assign SOAFiles - Prod Mode" sap:VirtualizedContainerService.HintSize="262,64" sap2010:WorkflowViewState.IdRef="Assign_6">
                    <Assign.To>
                      <OutArgument x:TypeArguments="s:String[]">[SOAFiles]</OutArgument>
                    </Assign.To>
                    <Assign.Value>
                      <InArgument x:TypeArguments="s:String[]" xml:space="preserve">[New DirectoryInfo(In_Config("soa_dir").ToString.Trim).
GetFiles("*.pdf", SearchOption.TopDirectoryOnly).
Where(Function(File) Not File.Attributes.HasFlag(FileAttributes.Hidden)).
Select(Function(File) File.FullName.Trim).ToArray]</InArgument>
                    </Assign.Value>
                  </Assign>
                </Sequence>
              </ui:CommentOut.Body>
              <sap:WorkflowViewStateService.ViewState>
                <scg:Dictionary x:TypeArguments="x:String, x:Object">
                  <x:Boolean x:Key="IsExpanded">False</x:Boolean>
                  <x:Boolean x:Key="IsPinned">False</x:Boolean>
                </scg:Dictionary>
              </sap:WorkflowViewStateService.ViewState>
            </ui:CommentOut>
          </Sequence>
        </If.Then>
        <If.Else>
          <Assign DisplayName="Assign SOAFiles" sap:VirtualizedContainerService.HintSize="262,64" sap2010:WorkflowViewState.IdRef="Assign_4">
            <Assign.To>
              <OutArgument x:TypeArguments="s:String[]">[SOAFiles]</OutArgument>
            </Assign.To>
            <Assign.Value>
              <InArgument x:TypeArguments="s:String[]" xml:space="preserve">[New DirectoryInfo(In_Config("soa_dir").ToString.Trim).
GetFiles("*.pdf", SearchOption.TopDirectoryOnly).
Where(Function(File) Not File.Attributes.HasFlag(FileAttributes.Hidden)).
Select(Function(File) File.FullName.Trim).ToArray]</InArgument>
            </Assign.Value>
          </Assign>
        </If.Else>
      </If>
      <If Condition="[SOAFiles.Count &gt; 0]" DisplayName="Check if there are SOA files available" sap:VirtualizedContainerService.HintSize="552,352" sap2010:WorkflowViewState.IdRef="If_2">
        <If.Then>
          <ui:ForEach x:TypeArguments="x:String" CurrentIndex="{x:Null}" DisplayName="Loop through SOAFiles" sap:VirtualizedContainerService.HintSize="307,194" sap2010:WorkflowViewState.IdRef="ForEach`1_2" Values="[SOAFiles]">
            <ui:ForEach.Body>
              <ActivityAction x:TypeArguments="x:String">
                <ActivityAction.Argument>
                  <DelegateInArgument x:TypeArguments="x:String" Name="SOAFile" />
                </ActivityAction.Argument>
                <ui:AddDataRow DataRow="{x:Null}" ArrayRow="[{ SOAFile }]" DataTable="[IO_Transactions]" DisplayName="Add SOAFile to Transactions" sap:VirtualizedContainerService.HintSize="200,22" sap2010:WorkflowViewState.IdRef="AddDataRow_2" />
              </ActivityAction>
            </ui:ForEach.Body>
          </ui:ForEach>
        </If.Then>
        <If.Else>
          <Throw DisplayName="No Transactions Loaded" Exception="[New Exception(&quot;[CVL Emailing: Initialize Process] No transactions loaded.&quot;)]" sap:VirtualizedContainerService.HintSize="200,22" sap2010:WorkflowViewState.IdRef="Throw_2" />
        </If.Else>
      </If>
      <ui:LogMessage DisplayName="Log Message" sap:VirtualizedContainerService.HintSize="552,91" sap2010:WorkflowViewState.IdRef="LogMessage_2" Level="Info" Message="[String.Format(&quot;[CVL Emailing: Initialize Process] &gt; [Initialize Transactions] SOA files: {0}&quot;, IO_Transactions.Rows.Count)]" />
    </Sequence>
    <Sequence DisplayName="Get results and datatables dictionary" sap:VirtualizedContainerService.HintSize="594,853" sap2010:WorkflowViewState.IdRef="Sequence_3">
      <sap:WorkflowViewStateService.ViewState>
        <scg:Dictionary x:TypeArguments="x:String, x:Object">
          <x:Boolean x:Key="IsExpanded">True</x:Boolean>
        </scg:Dictionary>
      </sap:WorkflowViewStateService.ViewState>
      <tca:GetResults ContinueOnError="{x:Null}" Config="[In_Config]" DisplayName="Get Results" sap:VirtualizedContainerService.HintSize="376,84" sap2010:WorkflowViewState.IdRef="GetResults_1" Results="[IO_Results]" />
      <Sequence DisplayName="Read map files" sap:VirtualizedContainerService.HintSize="376,637" sap2010:WorkflowViewState.IdRef="Sequence_4">
        <Sequence.Variables>
          <Variable x:TypeArguments="sd:DataTable" Name="ItemCodeMapDT" />
          <Variable x:TypeArguments="sd:DataTable" Name="ProcedureCodeMapDT" />
          <Variable x:TypeArguments="sd:DataTable" Name="CVLProcedureMapDT" />
        </Sequence.Variables>
        <sap:WorkflowViewStateService.ViewState>
          <scg:Dictionary x:TypeArguments="x:String, x:Object">
            <x:Boolean x:Key="IsExpanded">True</x:Boolean>
          </scg:Dictionary>
        </sap:WorkflowViewStateService.ViewState>
        <ui:ReadRange AddHeaders="True" DataTable="[ItemCodeMapDT]" DisplayName="Read Map File &gt; Item Code Map" sap:VirtualizedContainerService.HintSize="334,87" sap2010:WorkflowViewState.IdRef="ReadRange_1" Range="A1" SheetName="Item Code Map" WorkbookPath="[In_Config(&quot;map_file&quot;).ToString.Trim]" />
        <ui:ReadRange AddHeaders="True" DataTable="[ProcedureCodeMapDT]" DisplayName="Read Map File &gt; Procedure Code Map" sap:VirtualizedContainerService.HintSize="334,87" sap2010:WorkflowViewState.IdRef="ReadRange_2" Range="A1" SheetName="Procedure Code Map" WorkbookPath="[In_Config(&quot;map_file&quot;).ToString.Trim]" />
        <ui:ReadRange AddHeaders="True" DataTable="[CVLProcedureMapDT]" DisplayName="Read Map File &gt; CVL Procedure Map" sap:VirtualizedContainerService.HintSize="334,87" sap2010:WorkflowViewState.IdRef="ReadRange_3" Range="A1" SheetName="CVL Procedure Map" WorkbookPath="[In_Config(&quot;map_file&quot;).ToString.Trim]" />
        <ui:InvokeCode ContinueOnError="{x:Null}" Code="IO_DataTablesDictionary.Clear&#xA;&#xA;If Not IO_DataTablesDictionary.ContainsKey(&quot;Item Code Map&quot;) Then&#xA;&#x9;IO_DataTablesDictionary.Add(&quot;Item Code Map&quot;, In_ItemCodeMapDT)&#xA;Else&#xA;&#x9;IO_DataTablesDictionary(&quot;Item Code Map&quot;) = In_ItemCodeMapDT&#xA;End If&#xA;&#xA;If Not IO_DataTablesDictionary.ContainsKey(&quot;Procedure Code Map&quot;) Then&#xA;&#x9;IO_DataTablesDictionary.Add(&quot;Procedure Code Map&quot;, In_ProcedureCodeMapDT)&#xA;Else&#xA;&#x9;IO_DataTablesDictionary(&quot;Procedure Code Map&quot;) = In_ProcedureCodeMapDT&#xA;End If&#xA;&#xA;If Not IO_DataTablesDictionary.ContainsKey(&quot;CVL Procedure Map&quot;) Then&#xA;&#x9;IO_DataTablesDictionary.Add(&quot;CVL Procedure Map&quot;, In_CVLProcedureMapDT)&#xA;Else&#xA;&#x9;IO_DataTablesDictionary(&quot;CVL Procedure Map&quot;) = In_CVLProcedureMapDT&#xA;End If" DisplayName="Add datatables to datatables dictionary" sap:VirtualizedContainerService.HintSize="334,164" sap2010:WorkflowViewState.IdRef="InvokeCode_1">
          <ui:InvokeCode.Arguments>
            <InOutArgument x:TypeArguments="scg:Dictionary(x:String, sd:DataTable)" x:Key="IO_DataTablesDictionary">[IO_DataTablesDictionary]</InOutArgument>
            <InArgument x:TypeArguments="sd:DataTable" x:Key="In_ItemCodeMapDT">[ItemCodeMapDT]</InArgument>
            <InArgument x:TypeArguments="sd:DataTable" x:Key="In_ProcedureCodeMapDT">[ProcedureCodeMapDT]</InArgument>
            <InArgument x:TypeArguments="sd:DataTable" x:Key="In_CVLProcedureMapDT">[CVLProcedureMapDT]</InArgument>
          </ui:InvokeCode.Arguments>
        </ui:InvokeCode>
      </Sequence>
    </Sequence>
  </Sequence>
</Activity>